import globalPluginHandler
from speech import cancelSpeech
import scriptHandler
import api
import textInfos
import speech
from ui import message
import addonHandler
addonHandler.initTranslation()
import wx,gui
import time

class GlobalPlugin(globalPluginHandler.GlobalPlugin):

	def script_goToLine(self,gesture):
		
		#(line, column) = self.GetLineAndColumnNumber()
		line = self.getLineNumber()
		if line != 0:
			d = wx.TextEntryDialog(gui.mainFrame, _("Enter the line number you wish to jump to"), _("Jump to line"), str(line))
		else:
			d = wx.TextEntryDialog(gui.mainFrame, _("Enter the line number you wish to jump to"), _("Jump to line"))
		
		def callback(result):
			if result == wx.ID_OK:
				wx.CallLater(100,self.jumping, d.GetValue())
		
		gui.runScriptModalDialog(d, callback)
	script_goToLine.__doc__ = _("Go to line")
	
	def jumping(self,num):
		if not num.isdigit() :
			wx.CallAfter(gui.messageBox, _("The line number  that you have entered is not valid"), _("Error"), wx.OK|wx.ICON_ERROR)
			return
		obj=api.getFocusObject()
		treeInterceptor=obj.treeInterceptor
		if hasattr(treeInterceptor,'TextInfo') and not treeInterceptor.passThrough:
			obj=treeInterceptor
		try:
			self.start =obj.makeTextInfo(textInfos.POSITION_ALL)
		except (NotImplementedError, RuntimeError):
			return
		try:
			lineCount=self.start.unitCount(textInfos.UNIT_LINE)
		except AttributeError:
			lineCount="unknown"
			pass
		if int(num)>lineCount:
			wx.CallAfter(gui.messageBox, _("This text has {0} lines. Cannot go to line {1}").format(lineCount,num), _("Error"), wx.OK|wx.ICON_ERROR)
		try:
			self.start.move(textInfos.UNIT_LINE,int(num)-1,"start")
			self.start.updateCaret()
			self.start.expand(textInfos.UNIT_LINE)
			cancelSpeech()
			time.sleep(0.2)
			message(_("line %s") % str(num))
			
		except NotImplementedError:
			wx.CallAfter(gui.messageBox, _("This doesn't look like a proper text"), _("Error"), wx.OK|wx.ICON_ERROR)
			pass
		message(self.start.text)
	
	def getLineNumber(self):
		info=api.getReviewPosition().copy()
		lineCount = 0
		i = 2000
		while i != 0:
			i = i-1
			lineCount= lineCount+1
			try:
				info.expand(textInfos.UNIT_LINE)
				info.collapse()
				res=info.move(textInfos.UNIT_LINE,-1)
			except:
				return 0
				
			if res==0:
				# top of document
				break

		return lineCount
				
				
	__gestures = {
		"kb:NVDA+shift+j": "goToLine"
	}